//+----------------------------------------------------------------------------------
//  1.           
//         ,   . 
//                
//         -    . 
//
//  2.  . (     100  , 
//     0             .)
// 
//  3.            
//              20 
//               
//        >       - .
//
//  4.           
//              80 
//               
//        <        - .
//
//  5.   period = 0  period2 = 0,    .
//
//----------------------------------------------------------------------------------

#property strict
/*   */
extern double   LotsNumber = 0.05;                                      
extern double km = 2;          /*    - */    
extern int N = 2;              /*      */   
extern int sl = 500;
extern int tp = 300;
extern string comment = "10";       
extern int  MagicNumber = 1; 
extern int period = 5;         /*     */ 
extern int ma_method = 0;
extern int price = 0;
extern int tf = 0;            
extern int period2 = 30;        /*     */    
extern int ma_method2 = 0;
extern int price2 = 0;
extern int tf2 = 0;                     
extern int k = 5;              /*  %   */
extern int d = 3;              /*  %D   */
extern int z = 3;              /*     */
extern int m = 0;
extern int stu = 70;           /*  .  */
extern int std = 30;           /*   . */
extern int time = 15;          /*        */ 
int i,sch,ti,n;
double posl,ma1,ma2,l,K1,K2,D1,D2;
 
int init() {return(0);}

int deinit() {return(0);}

int start() {
for (i=OrdersTotal()-1;i>=0;i--){                                    /*     time  */
OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY && TimeCurrent()-OrderOpenTime()>=time*60){
OrderClose(OrderTicket(),OrderLots(),Bid,10,DarkGreen);}}

for (i=OrdersTotal()-1;i>=0;i--){                                    /*     time  */
OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL && TimeCurrent()-OrderOpenTime()>=time*60){
OrderClose(OrderTicket(),OrderLots(),Ask,10,DarkGreen);}}

ma1 = iMA(NULL,tf,period,0,ma_method,price,1);                        /*    */
ma2 = iMA(NULL,tf2,period2,0,ma_method2,price2,1); 

K1=iStochastic(NULL,0,k,d,z,m,0,MODE_MAIN,1);
K2=iStochastic(NULL,0,k,d,z,m,0,MODE_MAIN,2);
D1=iStochastic(NULL,0,k,d,z,m,0,MODE_SIGNAL,1);
D2=iStochastic(NULL,0,k,d,z,m,0,MODE_SIGNAL,2);

sch = 0; for(i=OrdersTotal()-1;i>=0;i--) {                           /*      */
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) sch++; } 

if(sch==0 && posl!=Open[0] && K1>D1 && K2<D2 && K1<std && Close[1]>ma1 && Close[1]>ma2 && ma1>=ma2){         /*     */
posl=Open[0];
OrderSelect(ti,SELECT_BY_TICKET);
if(OrderProfit()>0) {l=OrderLots()*km; n++;}
if(OrderProfit()<0 || n>N || ti==0){ l=LotsNumber; n=0;}
RefreshRates(); ti=OrderSend(Symbol(),OP_BUY,NormalizeDouble(l,2),Ask,100,0,0,comment,MagicNumber,0,DarkGreen);
while(ti<0){RefreshRates(); ti=OrderSend(Symbol(),OP_BUY,NormalizeDouble(l,2),Ask,100,0,0,comment,MagicNumber,0,DarkGreen);}} 

sch = 0; for(i=OrdersTotal()-1;i>=0;i--) {                           /*      */
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) sch++; } 

if(sch==0 && posl!=Open[0] && K1<D1 && K2>D2 && K1>stu && Close[1]<ma1 && Close[1]<ma2 && ma1<=ma2){         /*     */
posl=Open[0];
OrderSelect(ti,SELECT_BY_TICKET);
if(OrderProfit()>0) {l=OrderLots()*km; n++;}
if(OrderProfit()<0 || n>N || ti==0){ l=LotsNumber; n=0;} 
RefreshRates(); ti=OrderSend (Symbol(),OP_SELL,NormalizeDouble(l,2),Bid,100,0,0,comment,MagicNumber,0,Red);
while(ti<0){RefreshRates(); ti=OrderSend (Symbol(),OP_SELL,NormalizeDouble(l,2),Bid,100,0,0,comment,MagicNumber,0,Red);}}

for(i=OrdersTotal()-1;i>=0;i--){                                     /*      */
OrderSelect (i,SELECT_BY_POS,MODE_TRADES);
if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY && OrderStopLoss()==0 && sl!=0)
OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-sl*Point,OrderTakeProfit(),0,Blue);

if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY && OrderTakeProfit()==0 && tp!=0)
OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice()+tp*Point,0,Blue);

if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL && OrderStopLoss()==0 && sl!=0)
OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+sl*Point,OrderTakeProfit(),0,Blue);

if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL && OrderTakeProfit()==0 && tp!=0)
OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice()-tp*Point,0,Blue);}return(0);}
